<?php
/**
 * @file
 * Module to embed views using tokens
 */

use Drupal\Core\Render\BubbleableMetadata;

/**
 * Implements hook_token_info().
 */
function token_embed_views_token_info() {
  $info = array();
  $info['types']['token_embed_views'] = array(
    'name' => t('Token Embed Views'),
    'description' => t('Embed a view in a block with a token.'),
  );
  $info['tokens']['token_embed_views']['view'] = array(
    'name' => t('View'),
    'description' => t('Embed views using tokens. The following values may be appended to the token: view-name:display-id:arg1/arg2/arg3'),
  );

  return $info;
}

/**
 * Implements hook_tokens().
 */
function token_embed_views_tokens($type, $tokens, array $data, array $options, BubbleableMetadata $bubbleable_metadata) {
  $replacements = array();
  if ($type == 'token_embed_views') {

    foreach ($tokens as $name => $original) {
      $args = explode(':', $name);
      $view = call_user_func_array('views_embed_view', $args);
      $replacements[$original] = \Drupal::service('renderer')->render($view);
    }
  }

  return $replacements;
}
